テキストコントロールでは、入力した文字からふりがなを取得することができます。
ふりがなの取得
IMEを使用して文字を入力したときに、onIMEReadingStringOutputイベントが発生し、readingStringプロパティを使用して入力した文字のふりがなを取得することができます。また、IMEReadingStringAppendプロパティを設定することで、ふりがなを出力する方法を指定できます。
IMEReadingStringAppendプロパティを設定することで、ふりがなを出力する方法を指定できます。設定できる値は次のとおりで、既定値はtrueです。
IMEReadingStringAppendの値
説明
true
前に取得されたふりがなに追加します
false
前に取得されたふりがなを置き換えます
ふりがなの文字種
IMEReadingStringKanaModeプロパティを利用すると、出力されるふりがなの文字種を指定できます。設定できる値は次のとおりで、既定値はKanaMode.Hiraganaです。
KanaModeの値
説明
Hiragana
ふりがなをひらがなで出力します
Katakana
ふりがなを全角カタカナで出力します
KatakanaHalf
ふりがなを半角カタカナで出力します
import '@mescius/inputman/CSS/gc.inputman-js.css';
import { InputMan } from '@mescius/inputman';
InputMan.appearanceStyle = InputMan.AppearanceStyle.Modern;
const gcTextBox = new InputMan.GcTextBox(document.getElementById('gcTextBox'), {
IMEReadingStringAppend: false
});
const furigana = document.getElementById('furigana');
gcTextBox.onIMEReadingStringOutput((sender, eArgs) => {
furigana.innerText = eArgs.readingString;
});
document.getElementById('clearText').addEventListener('click', () => {
gcTextBox.setText('');
furigana.innerText = '';
});
document.getElementById('setReadingImeStringKanaMode').addEventListener('change', (e) => {
gcTextBox.IMEReadingStringKanaMode = kanaModes[e.target.selectedIndex];
});
const kanaModes = [
InputMan.KanaMode.KatakanaHalf,
InputMan.KanaMode.Katakana,
InputMan.KanaMode.Hiragana
];
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta http-equiv="X-UA-Compatible" content="ie=edge">
<title>テキストコントロール - ふりがなの取得</title>
<!-- SystemJS -->
<script src="node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
window.onload = function() {
System.import('./src/app');
}
</script>
</head>
<body>
<label>漢字入力: <input id="gcTextBox"></label><br>
<p>ふりがな: <span id="furigana"></span></p>
<button id="clearText">クリア</button>
<table class="sample">
<tr>
<th>ふりがなの文字種</th>
<td>
<select id="setReadingImeStringKanaMode">
<option>半角カタカナ</option>
<option>全角カタカナ</option>
<option>ひらがな</option>
</select>
</td>
</tr>
</table>
</body>
</html>
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/inputman': 'npm:@mescius/inputman/index.js',
'@mescius/inputman/CSS': 'npm:@mescius/inputman/CSS',
'@mescius/inputman.richtexteditor': 'npm:@mescius/inputman.richtexteditor/index.js',
"@mescius/inputman.richtexteditor/CSS": "npm:@mescius/inputman.richtexteditor/CSS",
'@mescius/inputman.richtexteditor/JS/plugins/advlist': 'npm:@mescius/inputman.richtexteditor/JS/plugins/advlist/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/all': 'npm:@mescius/inputman.richtexteditor/JS/plugins/all/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/autosave': 'npm:@mescius/inputman.richtexteditor/JS/plugins/autosave/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/charmap': 'npm:@mescius/inputman.richtexteditor/JS/plugins/charmap/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/directionality': 'npm:@mescius/inputman.richtexteditor/JS/plugins/directionality/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/emoticons': 'npm:@mescius/inputman.richtexteditor/JS/plugins/emoticons/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/fullscreen': 'npm:@mescius/inputman.richtexteditor/JS/plugins/fullscreen/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/htmlcode': 'npm:@mescius/inputman.richtexteditor/JS/plugins/htmlcode/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/image': 'npm:@mescius/inputman.richtexteditor/JS/plugins/image/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/link': 'npm:@mescius/inputman.richtexteditor/JS/plugins/link/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/lists': 'npm:@mescius/inputman.richtexteditor/JS/plugins/lists/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/media': 'npm:@mescius/inputman.richtexteditor/JS/plugins/media/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/pagebreak': 'npm:@mescius/inputman.richtexteditor/JS/plugins/pagebreak/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/preview': 'npm:@mescius/inputman.richtexteditor/JS/plugins/preview/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/save': 'npm:@mescius/inputman.richtexteditor/JS/plugins/save/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/searchreplace': 'npm:@mescius/inputman.richtexteditor/JS/plugins/searchreplace/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/table': 'npm:@mescius/inputman.richtexteditor/JS/plugins/table/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/template': 'npm:@mescius/inputman.richtexteditor/JS/plugins/template/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/wordcount': 'npm:@mescius/inputman.richtexteditor/JS/plugins/wordcount/plugin.js',
'@mescius/inputman.comment': 'npm:@mescius/inputman.comment/index.js',
'@mescius/inputman.comment/CSS': 'npm:@mescius/inputman.comment/CSS',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets/styles': 'npm:@mescius/spread-sheets/styles',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
}
});

テキストコントロールでは、入力した文字からふりがなを取得することができます。
ふりがなの取得
IMEを使用して文字を入力したときに、onIMEReadingStringOutputイベントが発生し、readingStringプロパティを使用して入力した文字のふりがなを取得することができます。また、IMEReadingStringAppendプロパティを設定することで、ふりがなを出力する方法を指定できます。
IMEReadingStringAppendプロパティを設定することで、ふりがなを出力する方法を指定できます。設定できる値は次のとおりで、既定値はtrueです。
IMEReadingStringAppendの値
説明
true
前に取得されたふりがなに追加します
false
前に取得されたふりがなを置き換えます
ふりがなの文字種
setReadingImeStringKanaModeメソッドを利用すると、出力されるふりがなの文字種を指定できます。設定できる値は次のとおりで、既定値はKanaMode.Hiraganaです。
KanaModeの値
説明
Hiragana
ふりがなをひらがなで出力します
Katakana
ふりがなを全角カタカナで出力します
KatakanaHalf
ふりがなを半角カタカナで出力します
import { bootstrapApplication } from '@angular/platform-browser';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { InputManModule } from "@mescius/inputman.angular";
import '@mescius/inputman/CSS/gc.inputman-js.css';
import { Component, enableProdMode } from '@angular/core';
import * as GC from "@mescius/inputman";
@Component({
selector: 'app-component',
templateUrl: './src/app.component.html',
imports: [InputManModule, BrowserModule, FormsModule],
standalone: true
})
export class AppComponent {
ngOnInit(): void {
GC.InputMan.appearanceStyle = GC.InputMan.AppearanceStyle.Modern;
}
public imeReadingStringKanaMode: GC.InputMan.KanaMode;
public furiganaText: string;
public text: string;
public kanaModes = [
GC.InputMan.KanaMode.KatakanaHalf,
GC.InputMan.KanaMode.Katakana,
GC.InputMan.KanaMode.Hiragana
];
public clear(): void {
this.furiganaText = "";
this.text = "";
}
}
export interface ComboItem<T1, T2> {
value: T1;
text: T2;
}
enableProdMode();
bootstrapApplication(AppComponent).catch(err => console.error(err));
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>テキストコントロール - ふりがなの取得</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
window.onload = function() {
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
}
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<label>漢字入力:
<gc-text-box [imeReadingStringKanaMode]="imeReadingStringKanaMode" [imeReadingStringAppend]="false"
(onIMEReadingStringOutput)="furiganaText=$event.eArgs.readingString" [(text)]="text"></gc-text-box></label><br>
<p>ふりがな: <span id="furigana">{{furiganaText}}</span></p>
<button (click)="clear()">クリア</button>
<table class="sample">
<tr>
<th>ふりがなの文字種</th>
<td>
<select id="setReadingImeStringKanaMode" (change)="imeReadingStringKanaMode=kanaModes[$event.target.selectedIndex]">
<option>半角カタカナ</option>
<option>全角カタカナ</option>
<option>ひらがな</option>
</select>
</td>
</tr>
</table>
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
//'reflect-metadata': 'npm:reflect-metadata/Reflect.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
//'rxjs': 'npm:rxjs',
//'rxjs/operators': 'npm:rxjs/operators',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'@mescius/inputman': 'npm:@mescius/inputman/index.js',
'@mescius/inputman.angular': 'npm:@mescius/inputman.angular/fesm2015/mescius-inputman.angular.mjs',
'@mescius/inputman.richtexteditor': 'npm:@mescius/inputman.richtexteditor/index.js',
'@mescius/inputman.richtexteditor.angular': 'npm:@mescius/inputman.richtexteditor.angular/fesm2015/mescius-inputman.richtexteditor.angular.mjs',
'@mescius/inputman/CSS': 'npm:@mescius/inputman/CSS',
'@mescius/inputman.richtexteditor/CSS': 'npm:@mescius/inputman.richtexteditor/CSS',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets/styles': 'npm:@mescius/spread-sheets/styles',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib': 'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts',
meta: {
"*.component.ts": {
loader: "system.component-loader.js"
}
}
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"@mescius/inputman": {
defaultExtension: 'js'
},
"@mescius/inputman.richtexteditor": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/inputman.angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
},
"@mescius/inputman.richtexteditor.angular": {
defaultExtension: 'mjs'
},
}
});
})(this);